#!/usr/local/bin/sbcl --script

;;; A little Lisp shell script. Choose your shebang e.g.
;;; #!/usr/local/bin/sbcl --script
;;; #!/usr/bin/clisp


;; Fetch command-line argument list
(defun fetcharglist ()
  "Tested for SBCL and CLISP only"
  (or 
    #+SBCL *posix-argv*
    #+CLISP (cons "clisp" ext:*args*)
    #+CMU extensions:*command-line-words*
    #+LISPWORKS system:*line-arguments-list*
    #+GCL si::*command-args*
    nil))


;; Fetch n.th argument only
(defun ntharg (pos)
    (nth pos (fetcharglist)))


;; E.g. @cmd-line a b c results in something like:
;; ("clisp" "a" "b" "c")
;; "b"
(print (fetcharglist))
(print (ntharg 2))
(terpri)
