;;; Miscellaneous functions


(defun pidigits(n)
  "Calc n digits of Pi"
  (let ((p 0)
    (r nil)
    (dpi 0))
  (dotimes (i (+ n 1))
    (incf p (/ (- (/ 4 (+ 1 (* 8 i)))
      (/ 2 (+ 4 (* 8 i)))
      (/ 1 (+ 5 (* 8 i)))
      (/ 1 (+ 6 (* 8 i))))
      (expt 16 i))))
  (dotimes (i (+ n 1))
    (multiple-value-setq (r p) (truncate p 10))
    (setf dpi (+ (* 10 dpi) r))
    (setf p (* p 10)))
  dpi))


(defun factors (n)
  "Find factors of argument n"
  (let ((l '()))
    (do ((current 1 (1+ current)))
      ((> current (/ n current)))
      (if (= 0 (mod n current))
      (if (= current (/ n current))
      (setf l (append l (list current)))
      (setf l (append l (list current (/ n current)))))))
  (sort l #'< )))


;; Some string output and a sample calculation
(print "Hello Lisp! Calculate Pi with 20 digits:")
(print (pidigits 20))
