;;; A small collection of classic recursive functions
;;; These are interesting to trace. See bottom lines.

(defun fac (n)
  "Calculate factorial n! for integers"
  (declare (type integer n))
  (if (zerop n) 1 (* n (fac (1- n)))))


(defun mylength (l)
  "Homemade list length"
  (if (atom l) 0 (1+ (mylength (cdr l)))))


(defun mygcd (m n)
  "Homemade Greatest Common Divisor"
  (setq m (abs m))  ; sign does not matter, so force
  (setq n (abs n))  ; positive for algorithm below
  (cond
    ((and (= m 0) (= n 0)) 0)  ; gcd(0,0) = 0
    ((and (= m 0) (> n 0)) n)  ; gcd(0,n) = n
    ((and (> m 0) (= n 0)) m)  ; gcd(m,0) = m
    ((and (> m n) (> n 0)) (mygcd n m))  ; reinvoke reversed
    (t (mygcd (mod n m) m))))  ; else reduce recursively


;; How to trace a function:
(trace fac)
(fac 4)
(untrace fac)
