/** *************************************************************************
 **
 ** Copyright (C) 2010 Heinz van Saanen
 **
 ** This file is part of the interactive editor CLedit.
 **
 ** CLedit may be used under the terms of the GNU General Public License
 ** version 3 or later as published by the Free Software Foundation and
 ** appearing in the file LICENSE.GPL included in this package.
 **
 ** CLedit is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
****************************************************************************/


#ifndef PROCESS_H
#define PROCESS_H


/** Includes **/
#include <QProcess>
#include <QTextEdit>


/** Process class **/
class Process : public QProcess {
	Q_OBJECT

public:
	Process( QObject *parent = 0 );
	~Process() {}

	bool m_active;
	void setCommand( QString &cmd );
	void write( QString &cmd );

signals:
	void messageOut( QString &mess );
	void procState( bool b );

public slots:
	void startSlot();
	void killSlot();
	void readSlot();
	void exitSlot( int exitCode, QProcess::ExitStatus exitStatus );

private:
	QProcess m_process;
	QString m_message;
	QString m_cmdStr;
};

// PROCESS_H
#endif
